LOCAL_PATH := $(call my-dir)

# grpc libraries
include $(CLEAR_VARS)
LOCAL_MODULE := libupb
LOCAL_SRC_FILES := ../../../grpc/libupb.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libgrpc
LOCAL_SRC_FILES := ../../../grpc/libgrpc.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_cord
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_cord.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_cord_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_cord_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_cordz_info
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_cordz_info.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_strings
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_strings.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_str_format_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_str_format_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_strings_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_strings_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_cordz_handle
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_cordz_handle.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_cordz_functions
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/strings/libabsl_cordz_functions.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_bad_optional_access
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/types/libabsl_bad_optional_access.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_bad_variant_access
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/types/libabsl_bad_variant_access.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_graphcycles_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/synchronization/libabsl_graphcycles_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_synchronization
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/synchronization/libabsl_synchronization.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_city
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/hash/libabsl_city.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_hash
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/hash/libabsl_hash.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_low_level_hash
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/hash/libabsl_low_level_hash.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_debugging_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/debugging/libabsl_debugging_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_symbolize
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/debugging/libabsl_symbolize.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_stacktrace
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/debugging/libabsl_stacktrace.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_demangle_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/debugging/libabsl_demangle_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_status
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/status/libabsl_status.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_statusor
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/status/libabsl_statusor.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_time_zone
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/time/libabsl_time_zone.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_time
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/time/libabsl_time.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_civil_time
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/time/libabsl_civil_time.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_raw_hash_set
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/container/libabsl_raw_hash_set.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_hashtablez_sampler
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/container/libabsl_hashtablez_sampler.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_int128
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/numeric/libabsl_int128.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_exponential_biased
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/profiling/libabsl_exponential_biased.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_pool_urbg
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_pool_urbg.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_distributions
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_distributions.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_seed_sequences
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_seed_sequences.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_platform
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_platform.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_seed_material
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_seed_material.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_randen_slow
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_randen_slow.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_randen_hwaes_impl
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_randen_hwaes_impl.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_randen_hwaes
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_randen_hwaes.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_internal_randen
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_internal_randen.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_random_seed_gen_exception
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/random/libabsl_random_seed_gen_exception.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_spinlock_wait
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/base/libabsl_spinlock_wait.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_log_severity
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/base/libabsl_log_severity.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_raw_logging_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/base/libabsl_raw_logging_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_base
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/base/libabsl_base.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_throw_delegate
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/base/libabsl_throw_delegate.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libabsl_malloc_internal
LOCAL_SRC_FILES := ../../../grpc/third_party/abseil-cpp/absl/base/libabsl_malloc_internal.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libz
LOCAL_SRC_FILES := ../../../grpc/third_party/zlib/libz.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libre2
LOCAL_SRC_FILES := ../../../grpc/third_party/re2/libre2.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libcrypto
LOCAL_SRC_FILES := ../../../grpc/third_party/boringssl-with-bazel/libcrypto.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libssl
LOCAL_SRC_FILES := ../../../grpc/third_party/boringssl-with-bazel/libssl.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libcares
LOCAL_SRC_FILES := ../../../grpc/third_party/cares/cares/lib/libcares.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libprotobuf
LOCAL_SRC_FILES := ../../../grpc/third_party/protobuf/libprotobuf.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libgpr
LOCAL_SRC_FILES := ../../../grpc/libgpr.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libaddress_sorting
LOCAL_SRC_FILES := ../../../grpc/libaddress_sorting.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := libgrpc++
LOCAL_SRC_FILES := ../../../grpc/libgrpc++.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)

LOCAL_MODULE := nerfviewer

include ../../../../cflags.mk

LOCAL_C_INCLUDES := \
					$(LOCAL_PATH)/../../../../../SampleCommon/Src \
                    $(LOCAL_PATH)/../../../../../SampleXrFramework/Src \
  					$(LOCAL_PATH)/../../../../../1stParty/OVR/Include \
  					$(LOCAL_PATH)/../../../../../1stParty/utilities/include \
  					$(LOCAL_PATH)/../../../../../3rdParty/stb/src \
  					$(LOCAL_PATH)/../../../../../3rdParty/khronos/openxr/OpenXR-SDK/include \
					$(LOCAL_PATH)/../../../Src/render.grpc.pb.h \
					$(LOCAL_PATH)/../../../Src/render.pb.h \
					$(HOME)/.local/include \

LOCAL_SRC_FILES		:= 	\
    ../../../Src/main.cpp \
	../../../Src/render.grpc.pb.cc \
	../../../Src/render.pb.cc \


# include default libraries
LOCAL_LDLIBS 			:= -llog -landroid -lGLESv3 -lEGL
LOCAL_SHARED_LIBRARIES	:= openxr_loader
LOCAL_STATIC_LIBRARIES 	:= samplexrframework \
	libupb \
	libgrpc \
	libabsl_cord \
	libabsl_cord_internal \
	libabsl_cordz_info \
	libabsl_strings \
	libabsl_str_format_internal \
	libabsl_strings_internal \
	libabsl_cordz_handle \
	libabsl_cordz_functions \
	libabsl_bad_optional_access \
	libabsl_bad_variant_access \
	libabsl_graphcycles_internal \
	libabsl_synchronization \
	libabsl_city \
	libabsl_hash \
	libabsl_low_level_hash \
	libabsl_debugging_internal \
	libabsl_symbolize \
	libabsl_stacktrace \
	libabsl_demangle_internal \
	libabsl_status \
	libabsl_statusor \
	libabsl_time_zone \
	libabsl_time \
	libabsl_civil_time \
	libabsl_raw_hash_set \
	libabsl_hashtablez_sampler \
	libabsl_int128 \
	libabsl_exponential_biased \
	libabsl_random_internal_pool_urbg \
	libabsl_random_distributions \
	libabsl_random_seed_sequences \
	libabsl_random_internal_platform \
	libabsl_random_internal_seed_material \
	libabsl_random_internal_randen_slow \
	libabsl_random_internal_randen_hwaes_impl \
	libabsl_random_internal_randen_hwaes \
	libabsl_random_internal_randen \
	libabsl_random_seed_gen_exception \
	libabsl_spinlock_wait \
	libabsl_log_severity \
	libabsl_raw_logging_internal \
	libabsl_base \
	libabsl_throw_delegate \
	libabsl_malloc_internal \
	libz \
	libre2 \
	libcrypto \
	libssl \
	libcares \
	libprotobuf \
	libgpr \
	libaddress_sorting \
	libgrpc++ 

include $(BUILD_SHARED_LIBRARY)

# protobuf file generation
PROTOC = protoc
GRPC_CPP_PLUGIN = grpc_cpp_plugin
GRPC_CPP_PLUGIN_PATH ?= `which $(GRPC_CPP_PLUGIN)`

render:
	$(PROTOC) --grpc_out=. --plugin=protoc-gen-grpc=$(GRPC_CPP_PLUGIN_PATH) render.proto
	$(PROTOC) --cpp_out=. render.proto

$(call import-module,SampleXrFramework/Projects/Android/jni)
$(call import-module,OpenXR/Projects/AndroidPrebuilt/jni)
